Bug 1228603 (CVE-2015-1789)

Summary: CVE-2015-1789 OpenSSL: out-of-bounds read in X509_cmp_time
Product: [Other] Security Response Reporter: Huzaifa S. Sidhpurwala <huzaifas>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: cdewolf, csutherl, dandread, darran.lofthouse, dknox, jason.greene, jawilson, jclere, jdoyle, lgao, mbabacek, myarboro, pgier, pslavice, rsvoboda, security-response-team, szidek, tmraz, twalsh, vtunka, weli
Target Milestone: ---Keywords: Reopened, Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20150611,reported=20150605,source=openssl,cvss2=4.3/AV:N/AC:M/Au:N/C:N/I:N/A:P,rhel-4/openssl=wontfix,rhel-5/openssl=affected,rhel-5/openssl097a=wontfix,rhel-6/openssl=affected,rhel-6/openssl098e=wontfix,rhel-7/openssl=affected,rhel-7/openssl098e=wontfix,eap-6/openssl=notaffected,jbews-1/openssl=notaffected,jbews-2/openssl=notaffected,fedora-all/openssl=affected,jbews-3/openssl=notaffected,cwe=CWE-125[auto]
Fixed In Version: Doc Type: Bug Fix
Doc Text:
An out-of-bounds read flaw was found in the X509_cmp_time() function of OpenSSL, which is used to test the expiry dates of SSL/TLS certificates. An attacker could possibly use a specially crafted SSL/TLS certificate or CRL (Certificate Revocation List), which when parsed by an application would cause that application to crash.
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-06-08 02:41:37 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1228618, 1228619, 1228620, 1228621, 1231051, 1234214    
Bug Blocks: 1227577    
Attachments:
Description Flags
Proposed patch for CVE-2015-1789 none

Description Huzaifa S. Sidhpurwala 2015-06-05 10:12:10 UTC
The following was reported by OpenSSL upstream:

X509_cmp_time does not properly check the length of the ASN1_TIME string and can read a few bytes out of bounds. In addition, X509_cmp_time accepts an arbitrary number of fractional seconds in the time string.

An attacker can use this to craft malformed certificates and CRLs of various sizes and potentially cause a segmentation fault, resulting in a DoS on applications that verify certificates or CRLs. TLS clients that verify CRLs are affected. TLS clients and servers with client authentication enabled may be affected if they use custom verification callbacks.

This issue affects all current OpenSSL versions: 1.0.2, 1.0.1, 1.0.0 and 0.9.8.

OpenSSL 1.0.2 users should upgrade to 1.0.2b
OpenSSL 1.0.1 users should upgrade to 1.0.1n
OpenSSL 1.0.0 users should upgrade to 1.0.0s
OpenSSL 0.9.8 users should upgrade to 0.9.8zg

This issue was reported to OpenSSL on 8th April 2015 by Robert Swiecki (Google), and independently on 11th April 2015 by Hanno Böck. The fix was developed by Emilia Käsper of the OpenSSL development team.


Acknowledgements:

Red Hat would like to thank the OpenSSL project for reporting this issue.

Comment 1 Huzaifa S. Sidhpurwala 2015-06-05 10:28:39 UTC
Created attachment 1035151 [details]
Proposed patch for CVE-2015-1789

Comment 4 Huzaifa S. Sidhpurwala 2015-06-12 05:55:55 UTC
Created openssl tracking bugs for this issue:

Affects: fedora-all [bug 1231051]

Comment 5 Tomas Hoger 2015-06-15 12:26:21 UTC
A blog post related to this issue from Hanno Böck, one of the original reporters:

https://blog.fuzzing-project.org/15-Out-of-bounds-read-in-OpenSSL-function-X509_cmp_time-CVE-2015-1789-and-other-minor-issues.html

It also provides a test case for this issue:

https://crashes.fuzzing-project.org/openssl-verify-oob.crt

Comment 7 errata-xmlrpc 2015-06-15 20:49:14 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7
  Red Hat Enterprise Linux 6

Via RHSA-2015:1115 https://rhn.redhat.com/errata/RHSA-2015-1115.html

Comment 8 Huzaifa S. Sidhpurwala 2015-06-16 01:35:36 UTC
Statement:

(none)

Comment 9 Fedora Update System 2015-06-21 00:19:06 UTC
openssl-1.0.1k-10.fc22 has been pushed to the Fedora 22 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2015-06-24 15:57:33 UTC
openssl-1.0.1k-10.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 errata-xmlrpc 2015-06-30 04:43:21 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 5

Via RHSA-2015:1197 https://rhn.redhat.com/errata/RHSA-2015-1197.html